/**
 * Polyfills are generally for IE 11 support and are base on polyfills provided
 * by Mozilla (https://developer.mozilla.org).
 */

if (!Element.prototype.matches) {
  Element.prototype.matches = Element.prototype.msMatchesSelector ||
                              Element.prototype.webkitMatchesSelector;
}

if (!Element.prototype.closest) {
  Element.prototype.closest = function closest(sel) {
    let el = this;

    do {
      if (el.matches(sel)) return el;
      el = el.parentElement || el.parentNode;
    } while (el !== null && el.nodeType === 1);

    return null;
  };
}

Number.isInteger = Number.isInteger || function isInteger(value) {
  return typeof value === 'number' &&
    Number.isFinite(value) &&
    Math.floor(value) === value;
};

/**
 * Polyfill property definitions must be:
 *   writable: true
 *   enumerable: false
 *   configurable: true
 *
 * Otherwise they will cause errors.
 */

if (!Object.assign) {
  Object.defineProperty(Object, 'assign', {
    value: function assign(target, ...args) {
      if (target == null) { // TypeError if undefined or null
        throw new TypeError('Cannot convert undefined or null to object');
      }

      const to = Object(target);

      args.forEach((source) => {
        Object.keys(source).forEach((key) => {
          if (source.hasOwnProperty(key)) to[key] = source[key];
        });
      });

      return to;
    },
    writable: true,
    configurable: true,
  });
}

if (!Object.entries) {
  Object.defineProperty(Object, 'entries', {
    value: function entries(obj) {
      return Object.keys(obj).map((key) => [key, obj[key]]);
    },
    writeable: true,
    configurable: true,
  });
}
